## How to contribute to Coraza WAF

#### **Did you find a bug?**

* **Do not open up a GitHub issue if the bug is a security vulnerability
  in Coraza**, and instead to refer to our [security policy](https://github.com/jptosso/coraza-waf/blob/v2/master/SECURITY.md).

* **Ensure the bug was not already reported** by searching on GitHub under [Issues](https://github.com/jptosso/coraza-waf/issues).

* If you're unable to find an open issue addressing the problem, [open a new one](https://github.com/jptosso/coraza-waf/issues/new). Be sure to include a **title and clear description**, as much relevant information as possible, and a **code sample** or an **executable test case** demonstrating the expected behavior that is not occurring.

#### **Did you write a patch that fixes a bug?**

* Open a new GitHub pull request with the patch.

* Ensure the PR description clearly describes the problem and solution. Include the relevant issue number if applicable.

* Before submitting, please commit using [pre-commit](https://pre-commit.com/) to validate your PR passes the quality tests

#### **Do you intend to add a new feature or change an existing one?**

* Suggest your change in the [Discussion](https://github.com/jptosso/coraza-waf/discussions/categories/ideas) and start writing code.

* Do not open an issue on GitHub until you have collected positive feedback about the change. GitHub issues are primarily intended for bug reports and fixes.

#### **Do you have questions about the source code?**

* Ask any question about how to use Coraza in the [community](https://github.com/jptosso/coraza-waf/discussions/categories/q-a).

#### **Do you want to contribute to the Coraza documentation?**

* Please go to [coraza.io repository](https://github.com/jptosso/coraza.io).

Coraza WAF is a volunteer effort. We encourage you to pitch in and join the team!

Thanks! :heart: :heart: :heart:

Coraza Team
